"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const unified_1 = __importDefault(require("unified"));
const unist_util_modify_children_1 = __importDefault(require("unist-util-modify-children"));
// FIXME: Type.
const hastUtilToText = require("hast-util-to-text");
const rehype_parse_1 = __importDefault(require("rehype-parse"));
const attacher = ({ highlighter, throwOnUnsupportedLanguage = false }) => (tree) => {
    unist_util_modify_children_1.default((node, index, parent) => {
        if (node.tagName === "pre" &&
            Array.isArray(node.children) &&
            node.children.length === 1 &&
            node.children[0].tagName === "code" &&
            typeof node.children[0].properties === "object" &&
            Array.isArray(node.children[0].properties.className) &&
            typeof node.children[0].properties.className[0] === "string" &&
            node.children[0].properties.className[0].startsWith("language-")) {
            const code = hastUtilToText(node);
            const language = node.children[0].properties.className[0].slice("language-".length);
            let highlightedCodeHTML;
            try {
                // FIXME: The ‘!’. See https://github.com/shikijs/shiki/pull/114.
                highlightedCodeHTML = highlighter.codeToHtml(code, language);
            }
            catch (error) {
                if (throwOnUnsupportedLanguage)
                    throw error;
                else
                    return;
            }
            parent.children[index] = hastParser.parse(highlightedCodeHTML);
        }
    })(tree);
};
const hastParser = unified_1.default().use(rehype_parse_1.default, { fragment: true });
exports.default = attacher;
//# sourceMappingURL=index.js.map