"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const unified_1 = __importDefault(require("unified"));
const remark_parse_1 = __importDefault(require("remark-parse"));
const remark_rehype_1 = __importDefault(require("remark-rehype"));
const _1 = __importDefault(require("."));
const rehype_stringify_1 = __importDefault(require("rehype-stringify"));
const shiki = __importStar(require("shiki"));
test("supported language", async () => {
    expect(unified_1.default()
        .use(remark_parse_1.default)
        .use(remark_rehype_1.default)
        .use(_1.default, {
        highlighter: await shiki.getHighlighter({ theme: "light-plus" }),
    })
        .use(rehype_stringify_1.default)
        .processSync(`
\`\`\`javascript
return unified()
\`\`\`
`)
        .toString()).toMatchInlineSnapshot(`"<pre class=\\"shiki\\" style=\\"background-color: #FFFFFF\\"><code><span class=\\"line\\"><span style=\\"color: #AF00DB\\">return</span><span style=\\"color: #000000\\"> </span><span style=\\"color: #795E26\\">unified</span><span style=\\"color: #000000\\">()</span></span></code></pre>"`);
});
test("text", async () => {
    expect(unified_1.default()
        .use(remark_parse_1.default)
        .use(remark_rehype_1.default)
        .use(_1.default, {
        highlighter: await shiki.getHighlighter({ theme: "light-plus" }),
    })
        .use(rehype_stringify_1.default)
        .processSync(`
\`\`\`text
Leandro Facchinetti
\`\`\`
`)
        .toString()).toMatchInlineSnapshot(`
    "<pre class=\\"shiki\\" style=\\"background-color: #FFFFFF\\"><code><span class=\\"line\\"><span style=\\"color: #000000\\">Leandro Facchinetti
    </span></span></code></pre>"
  `);
});
test("unsupported language", async () => {
    expect(unified_1.default()
        .use(remark_parse_1.default)
        .use(remark_rehype_1.default)
        .use(_1.default, {
        highlighter: await shiki.getHighlighter({ theme: "light-plus" }),
    })
        .use(rehype_stringify_1.default)
        .processSync(`
\`\`\`not-a-language
Leandro Facchinetti
\`\`\`
`)
        .toString()).toMatchInlineSnapshot(`
    "<pre><code class=\\"language-not-a-language\\">Leandro Facchinetti
    </code></pre>"
  `);
});
test("throw on unsupported language", async () => {
    await expect(async () => {
        unified_1.default()
            .use(remark_parse_1.default)
            .use(remark_rehype_1.default)
            .use(_1.default, {
            highlighter: await shiki.getHighlighter({ theme: "light-plus" }),
            throwOnUnsupportedLanguage: true,
        })
            .use(rehype_stringify_1.default)
            .processSync(`
\`\`\`not-a-language
Leandro Facchinetti
\`\`\`
`)
            .toString();
    }).rejects.toThrowErrorMatchingInlineSnapshot(`"No language registration for not-a-language"`);
});
//# sourceMappingURL=index.test.js.map